VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "ASPI und SPTI unter einem Hut"
   ClientHeight    =   1770
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4950
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1770
   ScaleWidth      =   4950
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdTest 
      Caption         =   "Test Unit Ready"
      Height          =   315
      Left            =   225
      TabIndex        =   2
      Top             =   1275
      Width           =   1740
   End
   Begin VB.ComboBox cboDrv 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   330
      Left            =   225
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   825
      Width           =   4515
   End
   Begin VB.Label lblInterface 
      Caption         =   "Label1"
      Height          =   240
      Left            =   225
      TabIndex        =   0
      Top             =   300
      Width           =   3990
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Original stammt von Arne Elster. http://actorics.de/rm_code/index.html
' Dieses Beispiel stammt von http://actorics.de/rm_code/code/cdrom/complete.zip
' Hier wurde nur dafr gesorgt, das die ASPI-Schnittstelle verwendet wird und
' das der Status der Schublade eines CDROM-Laufwerkes ermittelt werden.
' Vorausgesetzt: Korrekt installierter ASPI-Treiber von Adaptec.

Private Const SCSIOP_MECHANISM_STATUS As Long = &HBD
Private Const SCSI_SENSE_ILLEGAL_REQUEST As Long = &H5
Private Const SCSI_ADSENSE_ILLEGAL_COMMAND As Long = &H20

Private Type inquiry
    qualifier   As Byte
    rsvd1       As Byte
    version     As Byte
    respfmt     As Byte
    addlen      As Byte
    rsvd2       As Byte
    stuff(1)    As Byte
    vendor(7)   As Byte
    product(15) As Byte
    revision(3) As Byte
    rsvd3(1)    As Byte
    stuff2(37)  As Byte
End Type

Private scsi As ISCSI
Private aspi As clsASPI

Private Sub Init()

    Dim i           As Integer
    Dim strDrvID    As String
    
    lblInterface = "Ausgewhltes Interface: " & scsi.Interface
    
    ' alle gefundenen Laufwerke anzeigen
    For i = 1 To scsi.DriveCount
        strDrvID = scsi.DriveHandle(i)
        AddDrive strDrvID
    Next
    
    cboDrv.ListIndex = 0
    
End Sub

Private Sub AddDrive(driveid As String)

    Dim cdb(5)      As Byte     ' Command Descriptor Block
    Dim buffer      As inquiry  ' Datenpuffer
    Dim strName     As String   ' Laufwerkseintrag
    
    cdb(0) = &H12               ' INQUIRY OpCode
    cdb(4) = Len(buffer)        ' Datenzuweisungslnge
    
    ' INQUIRY ausfhren
    If scsi.ExecCMD(driveid, cdb, 6, DIR_IN, VarPtr(buffer), Len(buffer)) <> _
        STATUS_GOOD Then
        
        MsgBox "INQUIRY fr ein Laufwerk gescheitert.", vbExclamation
        
        ' Programm besser beenden,
        ' weil die Auswahl der Laufwerke
        ' in dieser simplen Demo auf dem
        ' Combo Listindex basiert
        Unload Me
    Else
    
        ' Laufwerksbuchstabe
        strName = scsi.DriveChar(driveid) & ": "
        
        ' Laufwerksname
        strName = strName & StrConv(buffer.vendor, vbUnicode)
        strName = strName & StrConv(buffer.product, vbUnicode)
        strName = strName & StrConv(buffer.revision, vbUnicode)
        
        ' Bus Position
        strName = strName & " (" & scsi.HostAdapter(driveid) & ":"
        strName = strName & scsi.TargetID(driveid) & ":"
        strName = strName & scsi.LUN(driveid) & ")"
        
        ' alle null chars entfernen
        strName = Replace(strName, Chr$(0), "")
        cboDrv.AddItem strName
    End If
    
End Sub

Private Sub cmdTest_Click()

    Dim strDrvID As String
    Dim cdb(11) As Byte
    Dim buffer(511) As Byte ' Datenpuffer
    
    cdb(0) = SCSIOP_MECHANISM_STATUS ' SCSIOP_MECHANISM_STATUS OpCode
    cdb(9) = &H8
    
    ' ber Combobox Listindex das Laufwerk auswhlen
    strDrvID = scsi.DriveHandle(cboDrv.ListIndex + 1)
    
    ' SCSIOP_MECHANISM_STATUS an Laufwerk senden
    Select Case scsi.ExecCMD(strDrvID, cdb, 12, DIR_IN, VarPtr(buffer(0)), 512)
    
    Case STATUS_GOOD:
    
        ' auswerten des Datenpuffers
        If (buffer(1) And &H10) = &H10 Then
        
            ' Schublade des Laufwerkes ist offen
            MsgBox "Die Schublade des CD-ROM Laufwerkes ist offen."
            
        Else
        
            ' Schublade des Laufwerkes ist geschlossen
            MsgBox "Die Schublade des CD-ROM Laufwerkes ist geschlossen."
            
        End If
        
    Case STATUS_CHKCOND:
    
        If scsi.LastSK = SCSI_SENSE_ILLEGAL_REQUEST And scsi.LastASC _
            = SCSI_ADSENSE_ILLEGAL_COMMAND Then
            
            MsgBox "Dieses Laufwerk untersttzt die Abfrage nach dem " & _
                "SCSIOP_MECHANISM_STATUS nicht."
                
        End If
        
        Debug.Print scsi.LastSK
        Debug.Print scsi.LastASC
        Debug.Print scsi.LastASCQ
        
    End Select
    
End Sub

Private Sub Form_Load()

    
    Set scsi = New clsASPI
    
    If False = (scsi.Installed And scsi.Initialized) Then
        MsgBox "Kein funktionierendes Interface gefunden!", vbExclamation
        Unload Me
    End If
    
    Init
    
End Sub

Private Sub Form_Unload(Cancel As Integer)

    Set scsi = Nothing

End Sub
